function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import LocationTask from "./utils/LocationTask";

// 内库使用
import Device from "./../Device";
import MapUtil from "./../MapUtil";
import Toast from "./../Toast";
import LoadingInstance from "./../Loading/instance.js";
import GeoUtil from "./../GeoUtil";
import Alert from "./../Alert/instance.js";
import ToastInstance from "./../Toast/instance.js";
import locale from "./../locale";

// 测试使用
// import { GeoUtil, Device, MapUtil, Toast, locale } from 'seedsui-react'
// import Alert from 'seedsui-react/lib/Alert/instance.js'
// import ToastInstance from 'seedsui-react/lib/Toast/instance.js'
// import LoadingInstance from 'seedsui-react/lib/Loading/instance.js'

var Bridge = {
  // 判断是否是主页
  isHomePage: function isHomePage(callback, rule) {
    if (rule && window.top.window.location.href.indexOf(rule) >= 0) {
      callback(true);
      return;
    }
    callback(false);
  },
  // 弹出toast
  toast: null,
  /**
   * @deprecated since version 5.2.8
   * 请使用Toast.show({content: ''})
   */
  showToast: function showToast(msg) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!msg) return;
    if (!this.toast) {
      // 提示错误
      this.toast = new ToastInstance({
        parent: document.body,
        maskClass: 'mask toast-mask' + (params.mask === false ? ' toast-propagation' : ''),
        toastClass: 'toast ' + (params.position ? params.position : 'middle'),
        icon: params.icon || '',
        delay: params.delay || 2000,
        html: msg
      });
    } else {
      this.toast.updateParams(_objectSpread(_objectSpread({}, params), {}, {
        maskClass: 'mask toast-mask' + (params.mask === false ? ' toast-propagation' : ''),
        toastClass: 'toast ' + (params.position ? params.position : 'middle'),
        icon: params.icon || '',
        delay: params.delay || 2000,
        html: msg
      }));
    }
    this.toast.show();
    if (params.success) {
      setTimeout(function () {
        params.success();
      }, params.delay ? Math.round(params.delay / 2) : 1000);
    }
  },
  // 弹出loading
  loading: null,
  /**
   * @deprecated since version 5.2.8
   * 请使用 Loading.show()
   */
  showLoading: function showLoading() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (!this.loading) {
      this.loading = new LoadingInstance(_objectSpread(_objectSpread({}, params), {}, {
        caption: params.caption || locale('正在加载...', 'SeedsUI_loading'),
        maskClass: 'mask loading-mask ' + (params.mask === false ? ' loading-propagation' : '')
      }));
    } else {
      this.loading.updateParams(_objectSpread(_objectSpread({}, params), {}, {
        caption: params.caption || locale('正在加载...', 'SeedsUI_loading'),
        maskClass: 'mask loading-mask ' + (params.mask === false ? ' loading-propagation' : '')
      }));
    }
    this.loading.show();
  },
  /**
   * @deprecated since version 5.2.8
   * 请使用 Loading.hide()
   */
  hideLoading: function hideLoading() {
    if (this.loading) {
      this.loading.hide();
    }
  },
  /**
   * @deprecated since version 5.2.8
   * 请使用 Loading.exists()
   */
  isLoading: function isLoading() {
    if (!this.loading) return false;
    return this.loading.mask.classList.contains(this.loading.params.loadingActiveClass);
  },
  // 弹出Alert
  alert: null,
  /**
   * @deprecated since version 5.2.8
   * 请使用Modal.alert({content: '', submitProps: {onClick: () => {}}})
   */
  showAlert: function showAlert(msg) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!this.alert) {
      this.alert = new Alert(_objectSpread(_objectSpread({
        buttonSubmitHTML: locale('确定', 'SeedsUI_ok'),
        // 实例化时需要国际化
        buttonCancelHTML: locale('取消', 'SeedsUI_cancel'),
        // 实例化时需要国际化
        onClickSubmit: function onClickSubmit(e) {
          if (params.success) params.success(e);else e.hide();
        }
      }, params), {}, {
        caption: msg
      }));
    } else {
      if (params) {
        this.alert.updateParams(_objectSpread(_objectSpread({
          buttonSubmitHTML: locale('确定', 'SeedsUI_ok'),
          // 实例化时需要国际化
          buttonCancelHTML: locale('取消', 'SeedsUI_cancel'),
          // 实例化时需要国际化
          onClickSubmit: function onClickSubmit(e) {
            if (params.success) params.success(e);else e.hide();
          }
        }, params), {}, {
          caption: msg
        }));
      }
    }
    this.alert.show();
  },
  // 弹出Confirm
  confirm: null,
  /**
   * @deprecated since version 5.2.8
   * 请使用Modal.confirm({content: '', submitProps: {onClick: () => {}}})
   */
  showConfirm: function showConfirm(msg) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!this.confirm) {
      this.confirm = new Alert(_objectSpread(_objectSpread({
        buttonSubmitHTML: locale('确定', 'SeedsUI_ok'),
        // 实例化时需要国际化
        buttonCancelHTML: locale('取消', 'SeedsUI_cancel'),
        // 实例化时需要国际化
        onClickSubmit: function onClickSubmit(e) {
          if (params.success) params.success(e);else e.hide();
        },
        onClickCancel: function onClickCancel(e) {
          e.errMsg = '';
          if (params.fail) params.fail(e);else e.hide();
        }
      }, params), {}, {
        caption: msg
      }));
    } else {
      if (params) {
        this.confirm.updateParams(_objectSpread(_objectSpread({
          buttonSubmitHTML: locale('确定', 'SeedsUI_ok'),
          // 实例化时需要国际化
          buttonCancelHTML: locale('取消', 'SeedsUI_cancel'),
          // 实例化时需要国际化
          onClickSubmit: function onClickSubmit(e) {
            if (params.success) params.success(e);
          },
          onClickCancel: function onClickCancel(e) {
            e.errMsg = '';
            if (params.fail) params.fail(e);else e.hide();
          }
        }, params), {}, {
          caption: msg
        }));
      }
    }
    this.confirm.show();
  },
  /**
   * 百度地图:获取当前位置名称, 已废弃, 请使用Map中的获取位置方法代替
   * @param {Object} params: {longitude: '', latitude: '', type 'wgs84 | gcj02', success: fn, fail: fn}
   * @return {Promise} result: {status: 0 成功, points 百度坐标}
   */
  getAddress: function getAddress() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (window.getAddressDefault && typeof window.getAddressDefault === 'function') {
      return window.getAddressDefault(params);
    }
    var mapUtil = new MapUtil();
    return mapUtil.getAddress([params.longitude, params.latitude], (params === null || params === void 0 ? void 0 : params.type) || 'gcj02', params);
  },
  // 以上API均废弃，请使用其它方法代替, 勿使用
  platform: Device.platform,
  // 获得版本信息
  getAppVersion: function getAppVersion() {
    return Device.platformVersion;
  },
  // 拨打电话
  tel: function tel(number) {
    if (Device.device === 'pc') {
      Toast.show({
        content: locale('此功能仅可在手机中使用', 'SeedsUI_only_mobile')
      });
      return;
    }
    if (isNaN(number)) return;
    window.location.href = 'tel:' + number;
  },
  /**
   * 获取当前地理位置, 所有平台都可以调用
   * @param {Object} params
   * @prop {String} type 'wgs84'|'gcj02'坐标类型微信默认使用国际坐标'wgs84',
   * @return {Object} {latitude: '纬度', longitude: '经度', speed:'速度', accuracy:'位置精度'}
   */
  getBrowserLocation: function getBrowserLocation(params) {
    // debug模拟定位
    if (this.debug) {
      if (LocationTask.locationTask) {
        LocationTask.locationTask.push(params);
        return;
      }
      LocationTask.locationTask = [];
      console.log('模拟浏览器定位...');
      setTimeout(function () {
        var _LocationTask$getLoca;
        var res = {
          errMsg: 'getLocation:ok',
          speed: '0.0',
          accuracy: '3.0.0'
        };
        if ((params === null || params === void 0 ? void 0 : params.type) === 'gcj02') {
          res.latitude = 39.909187;
          res.longitude = 116.397451;
        } else {
          res.latitude = 39.907783490367706;
          res.longitude = 116.39120737493609;
        }
        if (params.success) params.success(res);
        if (params.complete) params.complete(res);
        LocationTask === null || LocationTask === void 0 || (_LocationTask$getLoca = LocationTask.getLocationTask) === null || _LocationTask$getLoca === void 0 || _LocationTask$getLoca.call(LocationTask, res);
      }, 2000);
      return;
    }

    // 调用浏览器定位
    if (navigator.geolocation) {
      // 调用定位
      if (LocationTask.locationTask) {
        LocationTask.locationTask.push(params);
        return;
      }
      LocationTask.locationTask = [];
      console.log('调用浏览器定位...');
      navigator.geolocation.getCurrentPosition(function (position) {
        var longitude = position.coords.longitude;
        var latitude = position.coords.latitude;
        if (!longitude || !latitude) {
          if (params.fail) params.fail({
            errCode: 'LATLNG_ERROR',
            errMsg: "getLocation:fail ".concat(locale('定位失败', 'SeedsUI_location_failed'))
          });
        }
        console.log('调用浏览器定位成功', longitude, latitude);
        if (params.type === 'gcj02') {
          var points = GeoUtil.coordtransform([longitude, latitude], 'wgs84', 'gcj02');
          longitude = points[0];
          latitude = points[1];
        }
        var res = {
          errMsg: 'getLocation:ok',
          speed: position.coords.speed,
          accuracy: position.coords.accuracy,
          longitude: longitude,
          latitude: latitude
        };
        if (params.success) params.success(res);
        LocationTask.getLocationTask(res);
      }, function (error) {
        var _LocationTask$getLoca2;
        var errCode = '';
        var errMsg = '';
        switch (error.code) {
          case error.PERMISSION_DENIED:
            errCode = 'PERMISSION_DENIED';
            errMsg = "getLocation:fail ".concat(locale('定位失败,用户拒绝请求地理定位', 'SeedsUI_location_permission_denied_error'));
            break;
          case error.POSITION_UNAVAILABLE:
            errCode = 'POSITION_UNAVAILABLE';
            console.log("".concat(locale('定位失败,位置信息是不可用', 'SeedsUI_location_unavailable_error')));
            errMsg = "getLocation:fail ".concat(locale('定位失败,位置信息是不可用', 'SeedsUI_location_unavailable_error'));
            break;
          case error.TIMEOUT:
            errCode = 'TIMEOUT';
            console.log("".concat(locale('定位失败,位置信息是不可用', 'SeedsUI_location_overtime_error')));
            errMsg = "getLocation:fail ".concat(locale('定位失败,请求获取用户位置超时', 'SeedsUI_location_overtime_error'));
            break;
          case error.UNKNOWN_ERROR:
            errCode = 'UNKNOWN_ERROR';
            console.log("".concat(locale('定位失败,位置信息是不可用', 'SeedsUI_location_unknown_error')));
            errMsg = "getLocation:fail ".concat(locale('定位失败,定位系统失效', 'SeedsUI_location_unknown_error'));
            break;
          default:
            errCode = 'LOCATION_ERROR';
            console.log("".concat(locale('定位失败', 'SeedsUI_location_failed')));
            errMsg = "getLocation:fail ".concat(locale('定位失败', 'SeedsUI_location_failed'));
        }
        var res = {
          errCode: errCode,
          errMsg: errMsg
        };
        console.log('调用浏览器定位失败', res);
        if (params.fail) params.fail(res);
        LocationTask === null || LocationTask === void 0 || (_LocationTask$getLoca2 = LocationTask.getLocationTask) === null || _LocationTask$getLoca2 === void 0 || _LocationTask$getLoca2.call(LocationTask, res);
      }, {
        enableHighAccuracy: true,
        // 指示浏览器获取高精度的位置，默认为false
        timeout: 8000,
        // 指定获取地理位置的超时时间，默认不限时，单位为毫秒
        maximumAge: 0 // 最长有效期，在重复获取地理位置时，此参数指定多久再次获取位置。
      });
    } else {
      console.log("".concat(locale('当前浏览器不支持定位', 'SeedsUI_location_not_supported')));
      var res = {
        errMsg: "getLocation:fail ".concat(locale('当前浏览器不支持定位', 'SeedsUI_location_not_supported'))
      };
      if (params.fail) params.fail(res);
      LocationTask.getLocationTask(res);
    }
    return;
  },
  /**
   * 修改原生标题
   * @param {Object} params {title: '自定义标题'}
   */
  setTitle: function setTitle(params) {
    if (params && params.title) {
      if (typeof params.title === 'string') {
        window.top.document.title = params.title;
      } else if (typeof params.title === 'function') {
        params.title();
      }
    }
  },
  // 返回首页
  goHome: function goHome() {
    window.history.go(-1);
  },
  // 打开新的窗口
  openWindow: function openWindow() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (params.url) window.location.href = params.url;
  },
  // 兼容方法
  logOut: function logOut() {
    console.log('logOut方法仅在app上工作');
  },
  openLocation: function openLocation() {
    console.log('openLocation方法仅在app上工作');
  },
  chooseImage: function chooseImage() {
    console.log('chooseImage方法仅在app上工作');
  },
  uploadImage: function uploadImage() {
    console.log('uploadImage方法仅在app上工作');
  },
  previewFile: function previewFile() {
    console.log('previewFile方法仅在app上工作');
  }
};
export default Bridge;