function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// 官方文档: https://open.dingtalk.com/document/isvapp/read-before-development
// https://open.dingtalk.com/document/orgapp/jsapi-overview
// 鉴权: https://open.dingtalk.com/document/orgapp/jsapi-authentication

import BridgeBase from "./base";
// import LocationTask from './utils/LocationTask'
import _back from "./utils/back";
import _ready from "./utils/ready";

// 内库使用
// import GeoUtil from './../GeoUtil'

// 测试使用
// import { GeoUtil } from 'seedsui-react'

var Bridge = _objectSpread(_objectSpread({}, BridgeBase), {}, {
  ready: function ready(callback, options) {
    _ready(callback, options, Bridge);
  },
  back: function back(backLvl, options) {
    _back(backLvl, options, Bridge);
  },
  /**
   * 定制功能
   */
  /**
   * 获取当前地理位置
   * @param {Object} params
   * params: {
   * type {String}: 'wgs84'|'gcj02'坐标类型微信默认使用国际坐标'wgs84',
   * }
   * @returns {Object} {latitude: '纬度', longitude: '经度', speed:'速度', accuracy:'位置精度'}
   */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    // 钉钉定位需要鉴权, 使用浏览器定位代替
    BridgeBase.getBrowserLocation(params);
    // 钉钉定位需要鉴权
    // const { type, success, fail, complete } = params || {}
    // // 调用定位
    // if (LocationTask.locationTask) {
    //   LocationTask.locationTask.push(params)
    //   return
    // }
    // LocationTask.locationTask = []
    // console.log('调用钉钉定位...', params)
    // window.top.dd.device.geolocation.get({
    //   targetAccuracy: 200, // 精度200米
    //   coordinate: 1, // 高德坐标, 会加地址
    //   withReGeocode: false, // 不需要逆向解析
    //   useCache: false,
    //   onSuccess: (result) => {
    //     let latitude = result.latitude
    //     let longitude = result.longitude
    //     if (type === 'wgs84') {
    //       const points = GeoUtil.coordtransform([longitude, latitude], 'gcj02', 'wgs84')
    //       longitude = points[0]
    //       latitude = points[1]
    //     }
    //     let res = {
    //       latitude: latitude,
    //       longitude: longitude,
    //       address: result.address,
    //       accuracy: result.accuracy
    //     }
    //     if (success) success(res)

    //     if (complete) complete(res)
    //     LocationTask.getLocationTask(res)
    //   },
    //   onFail: (res) => {
    //     if (fail) {
    //       fail({
    //         errCode: res.errorCode,
    //         errMsg: res.errorMessage
    //       })
    //     }

    //     if (complete) complete(res)
    //     LocationTask.getLocationTask(res)
    //   }
    // })
  },
  /**
   * 扫码
   * @param {Object} params
   * @returns {Object} {latitude: '纬度', longitude: '经度', speed:'速度', accuracy:'位置精度'}
   */
  scanQRCode: function scanQRCode() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _ref = params || {},
      scanType = _ref.scanType,
      success = _ref.success,
      fail = _ref.fail;
    var type = 'all';
    if (scanType.length === 1) {
      if (scanType.includes('qrCode')) {
        type = 'qrCode';
      } else if (scanType.includes('barCode')) {
        type = 'barCode';
      }
    }
    window.top.dd.biz.util.scan({
      type: type,
      onSuccess: function onSuccess(res) {
        success && success({
          resultStr: res.text
        });
      },
      onFail: function onFail(res) {
        if (fail) {
          fail({
            errCode: res.errorCode,
            errMsg: res.errorMessage
          });
        }
      }
    });
  },
  /**
   * 照片预览
   * @param {Object} params
     {
       index: 0, // 当前显示图片索引，默认 0
       current: '', // 当前显示图片的http链接
       urls: [] // 需要预览的图片http链接列表
     }
   */
  previewImage: function previewImage(params) {
    var index = (params === null || params === void 0 ? void 0 : params.index) || 0;
    if (typeof (params === null || params === void 0 ? void 0 : params.index) !== 'number' && typeof (params === null || params === void 0 ? void 0 : params.current) === 'string') {
      index = params.urls.indexOf(params.current);
      if (index < 0) index = 0;
    }
    window.top.dd.biz.util.previewImage({
      urls: params.urls,
      current: params.urls[index]
    });
  },
  /**
   * 关闭窗口
   */
  closeWindow: function closeWindow() {
    window.top.dd.biz.navigation.close();
  },
  /**
   * 修改原生标题
   * @param {Object} params {title: '自定义标题'}
   */
  setTitle: function setTitle(params) {
    if (typeof (params === null || params === void 0 ? void 0 : params.title) === 'string') {
      window.top.dd.setNavigationTitle({
        title: params === null || params === void 0 ? void 0 : params.title
      });
    }
  },
  /**
   * 返回监听
   */
  onHistoryBack: function onHistoryBack(params) {
    console.log('钉钉不支持监听物理返回');
  }
});
export default Bridge;