var _excluded = ["type", "success", "fail"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// 官方文档: https://open.feishu.cn/document/client-docs/h5/
// 鉴权: https://open.feishu.cn/document/uYjL24iN/uQjMuQjMuQjM/authentication/h5sdkconfig

import BridgeBase from "./base";
import LocationTask from "./utils/LocationTask";
import _back from "./utils/back";
import _ready from "./utils/ready";
var Bridge = _objectSpread(_objectSpread({}, BridgeBase), {}, {
  ready: function ready(callback, options) {
    _ready(callback, options, Bridge);
  },
  back: function back(backLvl, options) {
    _back(backLvl, options, Bridge);
  },
  /**
   * 定制功能
   */
  // 配置鉴权
  init: function init(cb) {
    if (window.h5sdk && !window.top.h5sdk) {
      window.top.h5sdk = window.h5sdk;
    }
    if (window.tt && !window.top.tt) {
      window.top.tt = window.tt;
    }
    var isReady = false;
    if (window.top.h5sdk) {
      console.log('桥接文件已加载,调用ready!');
      window.top.h5sdk.ready(function () {
        isReady = true;
        if (typeof cb === 'function') cb();
      });
      window.h5sdk.error(function (err) {
        isReady = true;
        console.log('飞书桥接初始化失败:', err);
        if (typeof cb === 'function') cb({
          errMsg: 'Bridge ready fail'
        });
      });
      console.log('已调用ready');
    }
    setTimeout(function () {
      if (!isReady) {
        console.error('桥接超时, 如果无法使用本地能力, 请退出重试');
        if (typeof cb === 'function') cb({
          errMsg: 'Bridge ready timeout'
        });
      }
    }, 2000);
  },
  /**
   * 获取当前地理位置
   * @param {Object} params
   * params: {
   * type {String}: 'wgs84'|'gcj02'坐标类型微信默认使用国际坐标'wgs84',
   * }
   * @returns {Object} {latitude: '纬度', longitude: '经度', speed:'速度', accuracy:'位置精度'}
   */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _ref = params || {},
      type = _ref.type,
      _success = _ref.success,
      _fail = _ref.fail,
      otherParams = _objectWithoutProperties(_ref, _excluded);
    // 调用定位
    if (LocationTask.locationTask) {
      LocationTask.locationTask.push(params);
      return;
    }
    LocationTask.locationTask = [];
    console.log('调用飞书定位...', params);
    window.top.tt.getLocation(_objectSpread(_objectSpread({}, otherParams), {}, {
      // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
      type: type || 'gcj02',
      success: function success(res) {
        if (res.longitude && res.latitude) {
          if (_success) _success(res);
        } else {
          if (_fail) _fail(res);
        }
        LocationTask.getLocationTask(res);
      },
      fail: function fail(res) {
        if (_fail) _fail(res);
        LocationTask.getLocationTask(res);
      }
    }));
  },
  /**
   * 扫码
   * @param {Object} params
   * @returns {Object} {latitude: '纬度', longitude: '经度', speed:'速度', accuracy:'位置精度'}
   */
  scanQRCode: function scanQRCode() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _ref2 = params || {},
      scanType = _ref2.scanType,
      _success2 = _ref2.success,
      _fail2 = _ref2.fail;
    window.top.tt.scanCode({
      scanType: scanType,
      barCodeInput: true,
      success: function success(res) {
        _success2 && _success2(res);
      },
      fail: function fail(res) {
        _fail2 && _fail2(res);
      }
    });
  },
  /**
   * 照片预览
   * @param {Object} params
     {
       index: 0, // 当前显示图片索引，默认 0
       current: '', // 当前显示图片的http链接
       urls: [] // 需要预览的图片http链接列表
     }
   */
  previewImage: function previewImage(params) {
    var index = (params === null || params === void 0 ? void 0 : params.index) || 0;
    if (typeof (params === null || params === void 0 ? void 0 : params.index) !== 'number' && typeof (params === null || params === void 0 ? void 0 : params.current) === 'string') {
      index = params.urls.indexOf(params.current);
      if (index < 0) index = 0;
    }
    var current = params.urls[index];
    window.top.tt.previewImage({
      urls: params.urls,
      current: current,
      success: function success(res) {
        params.success && params.success(res);
      },
      fail: function fail(res) {
        params.fail && params.fail(res);
      }
    });
  },
  /**
   * 关闭窗口
   */
  closeWindow: function closeWindow() {
    window.top.dd.biz.navigation.close();
  },
  /**
   * 返回监听
   */
  onHistoryBack: function onHistoryBack(params) {
    console.log('飞书不支持监听物理返回');
  }
});
export default Bridge;