var _excluded = ["onPreviousMonth", "onNextMonth", "onPreviousYear", "onNextYear", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';

// 日历头部
var Header = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var onPreviousMonth = _ref.onPreviousMonth,
    onNextMonth = _ref.onNextMonth,
    onPreviousYear = _ref.onPreviousYear,
    onNextYear = _ref.onNextYear,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  // 容器
  var rootRef = useRef(null);

  // 暴露方法
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef
  }, props, {
    className: "calendar-header".concat(props !== null && props !== void 0 && props.className ? ' ' + props.className : '')
  }), /*#__PURE__*/React.createElement("div", {
    className: "calendar-previous-year",
    onClick: onPreviousYear
  }, "<<"), /*#__PURE__*/React.createElement("div", {
    className: "calendar-previous-month",
    onClick: onPreviousMonth
  }, "<"), /*#__PURE__*/React.createElement("div", {
    className: "calendar-title"
  }, children), /*#__PURE__*/React.createElement("div", {
    className: "calendar-next-month",
    onClick: onNextMonth
  }, ">"), /*#__PURE__*/React.createElement("div", {
    className: "calendar-next-year",
    onClick: onNextYear
  }, ">>"));
});
export default Header;