import React, { forwardRef } from 'react';
import getList from "./getList";
import valueToList from "./valueToList";
import listToValue from "./listToValue";

// 内库使用
import Picker from "./../../../Picker";

// 测试使用
// import { Picker } from 'seedsui-react'

// 日期选择
function Main(_ref, ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'date' : _ref$type,
    value = _ref.value,
    onChange = _ref.onChange;
  function handleChange(list) {
    var newValue = listToValue(list, type);
    onChange && onChange(newValue);
  }
  return /*#__PURE__*/React.createElement(Picker.Main, {
    ref: ref,
    value: valueToList(value, type),
    list: getList(value, type),
    onChange: handleChange
  });
}
export default /*#__PURE__*/forwardRef(Main);