import getCustomRangeId from "./../RangeMain/SelectorMain/getCustomRangeId";
import getDefaultRangeId from "./../RangeMain/SelectorMain/getDefaultRangeId";

// 内库使用
import DateUtil from "./../../DateUtil";

// 测试使用
// import { DateUtil } from 'seedsui-react'

// 显示名称
function getDisplayValue(_ref) {
  var value = _ref.value,
    type = _ref.type,
    rangeId = _ref.rangeId,
    ranges = _ref.ranges,
    separator = _ref.separator;
  // 自定义名称
  var customRangeId = getCustomRangeId(ranges);

  // 非自定义显示别名
  if (rangeId && rangeId !== customRangeId) {
    return rangeId;
  }
  if (!Array.isArray(value) || value.length !== 2) {
    return '';
  }

  // 自定义显示日期
  if (rangeId && rangeId === customRangeId) {
    return "".concat(DateUtil.format(value[0], type)).concat(separator || ' ~ ').concat(DateUtil.format(value[1], type));
  }

  // 显示默认别名
  var defaultRangeId = getDefaultRangeId(value, ranges, type);
  if (defaultRangeId && defaultRangeId !== customRangeId) {
    return defaultRangeId;
  }

  // 显示自定义日期
  return "".concat(DateUtil.format(value[0], type)).concat(separator || ' ~ ').concat(DateUtil.format(value[1], type));
}
export default getDisplayValue;