function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["format", "separator", "ModalProps", "diff", "defaultPickerValue", "onError", "onBeforeChange", "value", "type", "min", "max", "disabledStart", "disabledEnd", "allowClear", "onChange", "rangeId", "ranges", "titles", "SelectorProps", "DatePickerModalProps"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef } from 'react';
import defaultRanges from "./../RangeMain/defaultRanges";
import RangeModal from "./../RangeModal";
import getDisplayValue from "./getDisplayValue";

// 内库使用
import Combo from "./../../Modal/Combo";

// 测试使用
// import { Modal } from 'seedsui-react'
// const Combo = Modal.Combo

// 日期区间
var RangeCombo = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var format = _ref.format,
    separator = _ref.separator,
    ModalProps = _ref.ModalProps,
    diff = _ref.diff,
    defaultPickerValue = _ref.defaultPickerValue,
    onError = _ref.onError,
    onBeforeChange = _ref.onBeforeChange,
    value = _ref.value,
    type = _ref.type,
    min = _ref.min,
    max = _ref.max,
    disabledStart = _ref.disabledStart,
    disabledEnd = _ref.disabledEnd,
    allowClear = _ref.allowClear,
    _onChange = _ref.onChange,
    rangeId = _ref.rangeId,
    _ref$ranges = _ref.ranges,
    ranges = _ref$ranges === void 0 ? defaultRanges : _ref$ranges,
    titles = _ref.titles,
    SelectorProps = _ref.SelectorProps,
    DatePickerModalProps = _ref.DatePickerModalProps,
    props = _objectWithoutProperties(_ref, _excluded);
  var rangeIdRef = useRef(rangeId);
  return /*#__PURE__*/React.createElement(Combo, _extends({
    ref: ref
    // Combo
    ,
    displayValueFormatter: function displayValueFormatter() {
      return getDisplayValue({
        value: value,
        type: format || type,
        rangeId: rangeId || rangeIdRef.current,
        ranges: ranges,
        separator: separator
      });
    }
  }, props, {
    // Modal
    value: value,
    allowClear: allowClear,
    onChange: function onChange(newValue) {
      var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        newRangeId = _ref2.rangeId,
        ranges = _ref2.ranges;
      // 清空时需要记录空选中项
      if (!rangeId) {
        rangeIdRef.current = newRangeId;
      }
      _onChange && _onChange(newValue, {
        rangeId: newRangeId,
        ranges: ranges
      });
    },
    ModalComponent: RangeModal,
    ModalProps: _objectSpread(_objectSpread({}, ModalProps), {}, {
      defaultPickerValue: defaultPickerValue,
      type: type,
      diff: diff,
      onError: onError,
      onBeforeChange: onBeforeChange,
      // 记录选中项
      onRangeIdChange: function onRangeIdChange(newRangeId) {
        if (!rangeId) {
          rangeIdRef.current = newRangeId;
        }
      },
      min: min,
      max: max,
      disabledStart: disabledStart,
      disabledEnd: disabledEnd,
      allowClear: allowClear,
      rangeId: rangeId || rangeIdRef.current,
      ranges: ranges,
      titles: titles,
      SelectorProps: SelectorProps,
      DatePickerModalProps: DatePickerModalProps
    })
  }));
});
export default RangeCombo;