function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React from 'react';
import getCustomRangeId from "./../getCustomRangeId";
import getSelectorOptions from "./getSelectorOptions";

// 内库使用
import Selector from "./../../../../Selector";

// 测试使用
// import { Selector } from 'seedsui-react'

// 日期快捷选择
function Buttons(_ref) {
  var value = _ref.value,
    type = _ref.type,
    _onChange = _ref.onChange,
    rangeId = _ref.rangeId,
    ranges = _ref.ranges,
    titles = _ref.titles,
    SelectorProps = _ref.SelectorProps,
    allowClear = _ref.allowClear;
  // 获取自定义项的key，不是数组则为自定义项:
  var customRangeId = getCustomRangeId(ranges);
  return /*#__PURE__*/React.createElement(React.Fragment, null, typeof (titles === null || titles === void 0 ? void 0 : titles.selector) === 'string' ? /*#__PURE__*/React.createElement("p", {
    className: "datepicker-selector-caption"
  }, titles.selector) : null, /*#__PURE__*/React.createElement(Selector, _extends({
    columns: 3,
    allowClear: allowClear
  }, SelectorProps, {
    value: [{
      id: rangeId
    }],
    list: getSelectorOptions(ranges, function (item) {
      if (!(titles !== null && titles !== void 0 && titles.custom)) {
        return true;
      }
      // 过滤自定义选择, 放置到下行
      return item.id !== customRangeId;
    }),
    onChange: function onChange(newRange) {
      var _newRange$;
      var newRangeId = (newRange === null || newRange === void 0 || (_newRange$ = newRange[0]) === null || _newRange$ === void 0 ? void 0 : _newRange$.id) || '';
      var newValue = newRangeId && Array.isArray(ranges[newRangeId]) && ranges[newRangeId].length === 2 ? ranges[newRangeId] : value;
      _onChange && _onChange(newValue, {
        rangeId: newRangeId,
        ranges: ranges
      });
    }
  })), customRangeId && (titles === null || titles === void 0 ? void 0 : titles.custom) && /*#__PURE__*/React.createElement(React.Fragment, null, typeof (titles === null || titles === void 0 ? void 0 : titles.custom) === 'string' ? /*#__PURE__*/React.createElement("p", {
    className: "datepicker-selector-caption"
  }, titles.custom) : null, /*#__PURE__*/React.createElement(Selector, _extends({
    columns: 1,
    allowClear: allowClear
  }, SelectorProps, {
    value: [{
      id: rangeId
    }],
    list: [{
      id: customRangeId,
      name: customRangeId
    }],
    onChange: function onChange(newRange) {
      var _newRange$2;
      var newRangeId = (newRange === null || newRange === void 0 || (_newRange$2 = newRange[0]) === null || _newRange$2 === void 0 ? void 0 : _newRange$2.id) || '';
      var newValue = newRangeId && Array.isArray(ranges[newRangeId]) && ranges[newRangeId].length === 2 ? ranges[newRangeId] : value;
      _onChange && _onChange(newValue, {
        rangeId: newRangeId,
        ranges: ranges
      });
    }
  }))));
}
export default Buttons;