var _excluded = ["value", "type", "min", "max", "disabledStart", "disabledEnd", "allowClear", "onChange", "rangeId", "ranges", "titles", "portal", "SelectorProps", "DatePickerModalProps"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import getCustomRangeId from "./getCustomRangeId";
import getDefaultRangeId from "./getDefaultRangeId";
import Buttons from "./Buttons";
import Dates from "./Dates";

// 日期快捷选择
function RangeMain(_ref, ref) {
  var value = _ref.value,
    type = _ref.type,
    min = _ref.min,
    max = _ref.max,
    disabledStart = _ref.disabledStart,
    disabledEnd = _ref.disabledEnd,
    allowClear = _ref.allowClear,
    _onChange = _ref.onChange,
    rangeId = _ref.rangeId,
    ranges = _ref.ranges,
    titles = _ref.titles,
    portal = _ref.portal,
    SelectorProps = _ref.SelectorProps,
    DatePickerModalProps = _ref.DatePickerModalProps,
    props = _objectWithoutProperties(_ref, _excluded);
  // 自定义项id
  var customRangeId = getCustomRangeId(ranges);

  // 当前选中项id
  var defaultRangeId = getDefaultRangeId(value, ranges, type);
  var currentRangeId = rangeId !== null && rangeId !== void 0 ? rangeId : defaultRangeId;
  var mainRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: mainRef.current,
      getRootDOM: function getRootDOM() {
        return mainRef.current;
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "datepicker-selector".concat(props.className ? ' ' + props.className : ''),
    ref: mainRef
  }), /*#__PURE__*/React.createElement(Buttons, {
    value: value,
    type: type,
    onChange: _onChange,
    rangeId: currentRangeId,
    ranges: ranges,
    titles: titles,
    SelectorProps: SelectorProps,
    allowClear: allowClear
  }), customRangeId && currentRangeId === customRangeId && /*#__PURE__*/React.createElement(Dates, {
    DatePickerModalProps: DatePickerModalProps,
    portal: portal,
    type: type,
    allowClear: allowClear,
    value: value,
    min: min,
    max: max,
    disabledStart: disabledStart,
    disabledEnd: disabledEnd,
    onChange: function onChange(newValue) {
      _onChange && _onChange(newValue, {
        ranges: ranges,
        rangeId: customRangeId
      });
    }
  }));
}
export default /*#__PURE__*/forwardRef(RangeMain);