function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
// 内库使用
import locale from "./../../../locale";
import DateUtil from "./../../../DateUtil";

// 测试使用
// import { locale, DateUtil } from 'seedsui-react'

// 判断是否开始时间大于结束时间
function validateStartEnd(value, _ref) {
  var type = _ref.type,
    onError = _ref.onError;
  if ((value === null || value === void 0 ? void 0 : value[0]) instanceof Date === false || (value === null || value === void 0 ? void 0 : value[1]) instanceof Date === false) {
    return value;
  }
  var _value = _slicedToArray(value, 2),
    startDate = _value[0],
    endDate = _value[1];
  var greater = DateUtil.compare(startDate, endDate, type);
  if (greater > 0) {
    if (onError) {
      var isOk = onError({
        errMsg: locale('开始时间不能大于结束时间', 'SeedsUI_starttime_greater_than_endtime'),
        value: value
      });
      if (isOk === true) return value;
      return false;
    }
    return [endDate, startDate];
  }
  return value;
}
export default validateStartEnd;