var _excluded = ["children", "type"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';
import locale from "./../../locale";

// type: loading,complete,failed
var BottomLoading = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    type = _ref.type,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // 获取提示
  function getDefaultChildren() {
    return /*#__PURE__*/React.createElement("div", {
      className: "layout-main-bottom-loading-wrapper"
    }, /*#__PURE__*/React.createElement("div", {
      className: "layout-main-bottom-loading-caption"
    }, type === 'loading' && locale('正在加载...', 'SeedsUI_loading'), type === 'complete' && locale('没有更多数据了', 'SeedsUI_no_more_data'), type === 'failure' && locale('加载失败, 请稍后再试', 'SeedsUI_load_failed')));
  }
  return /*#__PURE__*/React.createElement("div", _extends({
    className: "layout-main-bottom-loading"
  }, props, {
    ref: rootRef
  }), !children && getDefaultChildren(), children);
});
export default BottomLoading;